/***********************************
 *                                 *
 * Typo.c - typo filter            *
 *                                 *
 * Written 01/12/90 by Andrew Pam  *
 * (c) 1990-93 Serious Cybernetics *
 *                                 *
 ***********************************/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#ifdef __MSDOS__    /* Borland C++ */
#define MSDOS
#endif /* __MSDOS__ */

char Typo(char Ch)
{ const char Table[2][4][15] =
    {{{'`','1','2','3','4','5','6','7','8','9','0','-','=','\\','\b'},
      {'\0', 'q','w','e','r','t','y','u','i','o','p','[',']','\n','\0'},
      {'\0', 'a','s','d','f','g','h','j','k','l',';','\'','\n','\0','\0'},
      {'\0', 'z','x','c','v','b','n','m',',','.','/','\0','\0','\0','\0'}},
     {{'~','!','@','#','$','%','^','&','*','(',')','_','+','|','\b'},
      {'\0', 'Q','W','E','R','T','Y','U','I','O','P','{','}','\n','\0'},
      {'\0', 'A','S','D','F','G','H','J','K','L',':','"','\n','\0','\0'},
      {'\0', 'Z','X','C','V','B','N','M','<','>','?','\0','\0','\0','\0'}}};

  register int  I, J, K, M = 1;
           char C = 0;

  /* Check to see if Ch occurs in Table */
  for (K = 0; M && (K < 2); K += M)
    for (J = 0; M && (J < 4); J += M)
      for (I = 0; M && (I < 15); I += M)
        M = Ch != Table[K][J][I];

  /* If so, randomly substitute an adjacent key */
  if (!M)
#ifdef MSDOS
    switch (random(8))
#else /* !MSDOS */
    switch (random() % 8)
#endif /* MSDOS */
    { case 0: if (J) C = Table[K][--J][I];      break;
      case 1: if (J) C = Table[K][--J][++I];	break;
      case 2:
      case 3: if (I > 1) C = Table[K][J][--I];	break;
      case 4:
      case 5: if (I < 15) C = Table[K][J][++I];	break;
      case 6: if ((I > 1) && (J < 3))
        C = Table[K][++J][--I];                 break;
      case 7: if (J < 3) C = Table[K][++J][I];
    };

  return C ? C : Ch;
};

int main()
{ int X;

  putchar('\n');
  X = getchar();
#ifdef MSDOS
  randomize();
#else /* !MSDOS */
  srandom(X);
#endif /* MSDOS */
  while (X != EOF)
  { /* 1% chance of a typo */
#ifdef MSDOS
    putchar(random(100) ? X : Typo(X));
#else /* !MSDOS */
    putchar(random() % 100 ? X : Typo(X));
#endif /* MSDOS */
    X = getchar();
  }
  return 0;
};
